#include "config.h"

#include <mysql.h>

#include "loaddata.h"

int add_db(unsigned long ip, unsigned long netgroup, DATA_TYPE bytes, char *date) {
	char	querybuffer[255];	
	int		rows;

	/* Build UPDATE query */
	sprintf(querybuffer, QUERY_UPIP, bytes, ip, netgroup, date);

	if (mysql_query(&mysql, querybuffer)) {
			fprintf(stderr, "add_db: mysql update gave an error %s\n", mysql_error(&mysql));
			return(1);
	}

	rows=mysql_affected_rows(&mysql);
#ifdef DEBUG
	printf("Rows: %d Query: %s\n",rows,querybuffer);
#endif
	/* More then 1 affected row ???? */
	if (rows > 1) {
			fprintf(stderr, "add_db: We had more then 1 affected row on an update of an unique table\n");
			return(1);
	} else if (rows <= 0) {
		/* Insert instead of update the datarecord */
		sprintf(querybuffer, QUERY_INSIP, date, ip, netgroup, bytes);
		if (mysql_query(&mysql, querybuffer)) {
			fprintf(stderr, "add_db: error while inserting %s\n",mysql_error(&mysql));
			return(1);
		}
	}		
	return(0);
}

int dumparray(struct iparoot_struct *root, char *date) {
	struct ipan_struct	*src;
	int					i,j;
	unsigned long		offset;

	/* Loop on source netgroups */
	while(root->no_address != 0) {
		src=root->source;	
		/* Loop on networks on source netgroup */
		while(src->begin != 0 || src->end != 0) {
			/* Loop on ip addresses in netgroup */
			for(i=0;i<=src->end-src->begin;i++) {
				/* Loop on destination netgroups */
				for(j=0;j<=root->no_netgroup;j++) {
					offset=root->destination[j].value+i+src->value;
					if(root->data[offset] != 0) {
#if 1
						printf("%10lu %10lu %10Lu\n",
							src->begin+i,
							root->destination[j].real,
							root->data[offset]);
#endif
						if (add_db(src->begin+i,
								root->destination[j].real,
								root->data[offset], date)) {

							/* We error but try to continue */
							fprintf(stderr, "Updated failed for %lu %lu %Lu\n",
								src->begin+i,
								root->destination[j].real,
								root->data[offset]);

						}
					}
				}
			}
			src++;
		}
		root++;
	}	
	return(0);
}
