#include <stdio.h>
#include <mysql.h>

/*
 * Standard network table for generic
 * Search routine ...
 */
#define DATA_TYPE unsigned long long

struct ipan_struct {
		unsigned long	begin,
						end,
						value,
						real;
};

struct iparoot_struct {
		unsigned long		no_address,		/* Number of ip addresses */
							no_netgroup;
		struct ipan_struct	*source;		/* Source networks */	
			/* get filled
			 * 				value = begin is offset to values table
			 */
		struct ipan_struct	*destination;	/* Destination networks */
			/* get filled
			 * 				value = netgroup_no
			 */
		DATA_TYPE 	*data;		/* IP Accounting values */	
			/* indexed by
			 * 		source.value + (ipaddress - source.begin) +
			 * 							sourceno * netgroup_no
			 */
};

#define QUERY_SOURCENG "select ng2ng.src_ng_id from ng2ng group by ng2ng.src_ng_id order by ng2ng.src_ng_id"
#define QUERY_SOURCENW "select network.begin,network.end,(network.end-network.begin) as size from netgroup,network where netgroup.netgroup_id = %d and netgroup.network_id = network.network_id order by size"
#define QUERY_DSTNW "select netgroup.netgroup_id,network.begin,network.end,(network.end-network.begin) as size from ng2ng,netgroup,network where ng2ng.src_ng_id = %d and ng2ng.dst_ng_id=netgroup.netgroup_id and netgroup.network_id = network.network_id order by netgroup.netgroup_id desc,size desc"
#define QUERY_UPIP "update acct set bytes=bytes+%Lu where acct.ipaddress = %lu and acct.netgroup_id = %lu and acct.month = %s"
#define QUERY_INSIP "insert into acct values ( %s, %lu, %lu, %Lu)"

extern struct iparoot_struct *buildarray(void );
extern unsigned long processciscodata(struct iparoot_struct *root, FILE *fd);
extern void add_root(unsigned long ip1, unsigned long ip2, DATA_TYPE bytes, struct iparoot_struct *root);
extern int dumparray(struct iparoot_struct *root, char *date);

extern MYSQL mysql;
