#include "config.h"

#include <stdio.h>
#include <assert.h>

#include "loaddata.h"

void usage(void ) {
	printf("Usage:\n\tloaddata [datatype] [filename] [yymmdd]\n\n");
	exit(0);
}

int main(int argc, char **argv) {
	FILE					*fd;
	struct iparoot_struct 	*root;
	unsigned long 			lines;
	int						error;

	if (argc != 4) 
		usage();

	if (!(fd=fopen(argv[2],"r"))) {
			fprintf(stderr, "Unable to open file\n");
			exit(1);
	}

	if (!(root=buildarray())) 
		exit(1);
		
	switch(argv[1][0]) {
			case 'c':
					if (!(lines=processciscodata(root,fd))) 
						exit(1);
					break;
			default:
					usage();
	}

	fclose(fd);

	/* Dump array and set return value */	
	if ((error=dumparray(root, argv[3]))) 
			exit(error);

	printf("Processed %lu lines\n",lines);
	exit(0);
}
